int main()
{
	GDALAllRegister();

	const char *pszFormat = "GTiff";
	GDALDriver *poDriver;
	poDriver = GetGDALDriverManager()->GetDriverByName(pszFormat);

	GDALDataset *mask;
	char **papszOptions = NULL;
	papszOptions = CSLSetNameValue(papszOptions, "SPARSE_OK", "FALSE");
	mask = poDriver->Create("D:\\mask.tif", 512, 512, 1, GDT_Float32, papszOptions);

	double adfGeoTransform[6] = { 444720, 1, 0, 3751320, 0, -1 };
	char *pszSRS_WKT = NULL;
	GDALRasterBand *poBand;
	OGRSpatialReference oSRS;

	oSRS.SetUTM(11, TRUE);
	oSRS.SetWellKnownGeogCS("NAD27");
	oSRS.exportToWkt(&pszSRS_WKT);
	mask->SetProjection(pszSRS_WKT);
	CPLFree(pszSRS_WKT);
	mask->SetGeoTransform(adfGeoTransform);

	poBand = mask->GetRasterBand(1);
	
	//If we comment the next line, SPARSE_OK=FALSE is fine
	poBand->SetNoDataValue(-32767.0);

	GDALClose((GDALDatasetH)mask);


	//Copy the file with CreateCopy. SPARSE_OK=FALSE is then ignored
	char **papszOptions2 = NULL;
	papszOptions2 = CSLSetNameValue(papszOptions2, "SPARSE_OK", "FALSE");

	GDALDataset *poSrcDS = (GDALDataset *)GDALOpen("D:\\mask.tif", GA_ReadOnly);
	GDALDataset *poDstDS 
	poDstDS = poDriver->CreateCopy("D:\\maskCopy.tif", poSrcDS, TRUE, papszOptions2, NULL, NULL);

	if (poDstDS != NULL)
		GDALClose((GDALDatasetH)poDstDS);
	GDALClose((GDALDatasetH)poSrcDS);
}